unit PrintHtm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActnList, ComCtrls, ToolWin, ExtCtrls, OleCtrls, SHDocVw, ShellAPI,
  ImgList, Menus, StdCtrls, FileCtrl, Grids;

type
  TFmPrintHtm = class(TForm)
    ControlBar1: TControlBar;
    ToolBar1: TToolBar;
    WebBrowser1: TWebBrowser;
    PrintBtn: TToolButton;
    ImageListMuteren: TImageList;
    MainMenu1: TMainMenu;
    Print1: TMenuItem;
    MenuAdrukken: TMenuItem;
    Sluiten1: TMenuItem;
    ActionList1: TActionList;
    ActionPrint: TAction;
    ActionExit: TAction;
    N1: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    Info1: TMenuItem;
    ActionInfo: TAction;
    MyInfo: TMenuItem;
    ActionLoopupHist: TAction;
    ToolButton4: TToolButton;
    StringGrid1: TStringGrid;
    Splitter1: TSplitter;
    PopupMenu1: TPopupMenu;
    DoDelete: TMenuItem;
    procedure ActionPrintExecute(Sender: TObject);
    procedure ActionExitExecute(Sender: TObject);
    procedure ActionLoopupHistExecute(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure DoDeleteClick(Sender: TObject);
    procedure ActionInfoExecute(Sender: TObject);
  private
    { Private declarations }
    Flags      : OleVariant;
    cPrintFile : WideString;
    cDir       : String;
    Procedure VulGrid;
  public
    { Public declarations }
  end;

Procedure DoPrintHtm(cFile : String);

implementation

{$R *.DFM}

Uses MYInfo;

Procedure DoPrintHtm(cFile : String);
Begin
  if FileExists(cFile) or (cFile = '') then
    with TFmPrintHtm.Create(Application) do
    Try
      GetDir(0, cDir);
      Flags := navNoHistory + navNoReadFromCache + navNoWriteToCache;
      if cFile = '' then
      Begin
        ActionLoopupHistExecute(nil);
        Splitter1.Visible   := TRUE;
        StringGrid1.Visible := TRUE;
        Toolbutton4.Down    := Splitter1.Visible;
      end
      else
      Begin
        cPrintFile := cDir + '\' + cFile;
        if not FileExists(cPrintFile) then
        Begin
          ShowMessage('Printerfile "' + cPrintFile + '" not found.');
        end;
        Application.ProcessMessages;
        WebBrowser1.Navigate(cPrintFile, Flags);
        Application.ProcessMessages;
      end;
      ShowModal;
    finally
      Free;
    end;
end;

procedure TFmPrintHtm.ActionPrintExecute(Sender: TObject);
Var
  P : PChar;
begin
  // Print page...
  if cPrintFile = '' then Exit;
  GetMem(P, Length(cPrintFile) + 1);
  ShellExecute(Handle,'Print', StrPCopy(P, cPrintFile), nil, nil, SW_SHOW);
  FreeMem(P, Length(cPrintFile) + 1);
  ActionExitExecute(nil);
  Application.ProcessMessages;
end;

procedure TFmPrintHtm.ActionExitExecute(Sender: TObject);
begin
  WebBrowser1.Stop;
  Close;
end;

Procedure TFmPrintHtm.VulGrid;
Var
  MyDir  : TSearchRec;
  nFound : Integer;
  nCount : Integer;
Begin
  if StringGrid1.RowCount = 1 then With StringGrid1 do
  Begin
    nCount := 0;
    nFound := FindFirst('*.HTM*', faArchive, MyDir);
    if nFound = 0 then
    Begin
      ColWidths[0] := 110;
      ColWidths[1] := 60;
      ColWidths[2] := 50;

      RowCount := nCount + 1;
      Cells[0, nCount] := 'NAME';
      Cells[1, nCount] := 'DATE';
      Cells[2, nCount] := 'TIME';
      Inc(nCount);
    end;
    While nFound = 0 do
    Begin
      RowCount := nCount + 1;
      Cells[0, nCount] := MyDir.Name;
      Cells[1, nCount] := DateToStr(FileDateToDateTime(MyDir.Time));
      Cells[2, nCount] := TimeToStr(FileDateToDateTime(MyDir.Time));
      nFound := FindNext(MyDir);
      Inc(nCount);
    end;
    FindClose(MyDir);
    if nCount > 1 then FixedRows := 1;
  end;
end;

procedure TFmPrintHtm.ActionLoopupHistExecute(Sender: TObject);
begin
  Splitter1.Visible   := not Splitter1.Visible;
  StringGrid1.Visible := Splitter1.Visible;
  Toolbutton4.Down    := Splitter1.Visible;
  VulGrid;
end;

procedure TFmPrintHtm.StringGrid1Click(Sender: TObject);
Var
  Flags: OleVariant;
Const
  nLast : Integer = -99;
begin
  if StringGrid1.RowCount > 1 then With StringGrid1 do
  Begin
    if nLast <> Row then // Alleen laden als het een ander bestand betreft...
    Begin
      cPrintFile := cDir + '\' + Cells[0, Row];
      WebBrowser1.Navigate(cPrintFile, Flags);
      nLast := Row;
    end;
  end;
end;

procedure TFmPrintHtm.DoDeleteClick(Sender: TObject);
begin
  if StringGrid1.RowCount > 1 then With StringGrid1 do
  Begin
    if MessageDlg('Delete printerfile "' + Cells[0, Row] + '" ?',
                  mtConfirmation, [mbOk, mbCancel], 0) = mrOk then
    Begin
      SysUtils.DeleteFile(cDir + '\' + Cells[0, Row]);
      StringGrid1.RowCount := 1;
      VulGrid;
    end;
  end;
end;

procedure TFmPrintHtm.ActionInfoExecute(Sender: TObject);
begin
  ShowInfo;
end;

end.
